addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "hessesonic")
			if not (player.mo.tyssondrpdsh)
				player.mo.tyssondrpdsh = 0
			end
			if not (player.mo.tyssondrpdsh2)
				player.mo.tyssondrpdsh2 = 0
			end
			if not player.mo.tyssondrpdsh
				player.mo.tyssondrpdsh2 = 0
			end
			if not (player.mo.spindowndrpdh)
				player.mo.spindowndrpdh = 0
			end
			if not (player.mo.spindowndrpdh2)
				player.mo.spindowndrpdh2 = 0
			end
			if (P_IsObjectOnGround(player.mo))
				player.mo.spindowndrpdh2 = 0
				player.mo.spindowndrpdh = 1
				if player.mo.tyssondrpdsh == 1
				    if player.powers[pw_super]
					   P_RadiusAttack(player.mo, player.mo, 800*FRACUNIT)
					   P_StartQuake(10*FRACUNIT, TICRATE/2)
					end
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.mo.state = S_PLAY_TYSSONROLL
					if player.powers[pw_super]
					   P_InstaThrust(player.mo, player.mo.angle, (player.mo.tyssondrpdsh2*FRACUNIT)*3/2)
					else
					   P_InstaThrust(player.mo, player.mo.angle, player.mo.tyssondrpdsh2*FRACUNIT)
					end
					S_StartSound(player.mo, sfx_zoom)
					player.mo.tyssondrpdsh = 0
					player.pflags = $1|PF_SPINNING
					player.mo.tyssondrpdsh2 = 0
					local tyssonmode = P_SpawnGhostMobj(player.mo) 
					if tyssonmode and tyssonmode.valid
						tyssonmode.color = player.mo.color
						tyssonmode.colorized = true
						tyssonmode.destscale = $ * 8
						tyssonmode.blendmode = AST_ADD
						tyssonmode.target = player.mo
					end
					local hessering = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
					hessering.state, hessering.angle = S_FACESTABBERSPEAR, player.drawangle+ANGLE_90
					hessering.blendmode, hessering.color = AST_ADD, SKINCOLOR_SILVER
					hessering.destscale, hessering.fuse, hessering.tics = hessering.scale*2, 5, 20
				end
				if player.mo.state == S_PLAY_TYSSONROLL
					if player.pflags & PF_SPINNING and player.mo.state == S_PLAY_ROLL 
					and not (player.pflags & (PF_USEDOWN|PF_STARTDASH))
						if not player.hesse_machmode
							local dust2 = P_SpawnMobj(player.mo.x+(P_RandomRange(-15, 15)*FRACUNIT), player.mo.y, player.mo.floorz, MT_SPINDUST)
							dust2.scale = $*P_RandomRange(3/2, 3)
							if player.mo.eflags & MFE_VERTICALFLIP
								dust2.z = player.mo.ceilingz - 4*FRACUNIT
							else
								dust2.z = player.mo.floorz
							end
						end
					end
				end
			end
			if player.mo.tyssondrpdsh == 1
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				if (player.cmd.buttons & BT_USE)
					player.pflags = $1 & ~PF_SPINNING
					player.mo.state = S_PLAY_TYSSONDROPDASH
					if player.mo.tyssondrpdsh2 <= 85
						player.mo.tyssondrpdsh2 = $1 + 2
					else
						if player.hesse_machmode == true
							if player.mo.tyssondrpdsh2 >= 85
								player.mo.tyssondrpdsh2 = 85
							end
						else
							if player.mo.tyssondrpdsh2 >= 60
								player.mo.tyssondrpdsh2 = 60
							end
						end
					end
				else
					player.mo.state = S_PLAY_TYSSONDROPDASH_END
					player.mo.spindowndrpdh2 = 1
					player.mo.tyssondrpdsh2 = 0
					player.mo.tyssondrpdsh = 0
					player.mo.spindowndrpdh = 1
				end
			end
			if player.mo.state == S_PLAY_TYSSONDROPDASH_END
			or player.mo.state == S_PLAY_SPINDASH
			or player.powers[pw_carry]
			or P_PlayerInPain(player)
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.mo.tyssondrpdsh2 = 1
				player.mo.tyssondrpdsh = 0
				player.mo.spindowndrpdh = 1
			end
			if player.mo.state == S_PLAY_TYSSONDROPDASH
				player.mo.spritexscale = FRACUNIT+FixedDiv(player.mo.momz/96,player.mo.scale)
				player.mo.spriteyscale = FRACUNIT-FixedDiv(player.mo.momz/96,player.mo.scale)
			end
			if player.mo.state != S_PLAY_TYSSONDROPDASH
			and not player.powers[pw_carry] == CR_NIGHTSMODE
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
				if player.mo.tyssondrpdsh == 1
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.mo.state = S_PLAY_SPRING
					player.mo.momz = $*5/4
					player.mo.momx = $*5/4
					player.mo.momy = $*5/4
					S_StartSound(player.mo, sfx_sprong)
					player.mo.spindowndrpdh2 = 0
					player.mo.tyssondrpdsh2 = 0
					player.mo.tyssondrpdsh = 0
					player.mo.spindowndrpdh = 1
				end
			end
			if player.mo.tyssondrpdsh2 >= 30
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				if (leveltime % 10) == 8
					local tyssonmode = P_SpawnGhostMobj(player.mo) 
					if tyssonmode and tyssonmode.valid
						tyssonmode.color = player.mo.color
						tyssonmode.colorized = true
						tyssonmode.destscale = $ * 2
						tyssonmode.blendmode = AST_ADD
						tyssonmode.target = player.mo
					end
				end
			end
			if not (player.cmd.buttons & BT_USE)
				player.mo.spindowndrpdh = 0
			end
			if player.mo.tyssondrpdsh2 >= 60
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				if (leveltime % 3) == 1
					local tyssonmode = P_SpawnGhostMobj(player.mo) 
					if tyssonmode and tyssonmode.valid
						tyssonmode.color = player.mo.color
						tyssonmode.colorized = true
						tyssonmode.destscale = $ * 5
						tyssonmode.blendmode = AST_ADD
						tyssonmode.target = player.mo
					end
				end
			end
			if player.mo.tyssondrpdsh2 >= 85
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				if (leveltime % 3) == 1
					local tyssonmode = P_SpawnGhostMobj(player.mo) 
					if tyssonmode and tyssonmode.valid
						tyssonmode.color = SKINCOLOR_SAPPHIRE
						tyssonmode.colorized = true
						tyssonmode.destscale = $ * 8
						tyssonmode.blendmode = AST_ADD
						tyssonmode.target = player.mo
					end
				end
			end
			if player.playerstate == PST_LIVE
			and P_PlayerInPain(player)
			and player.powers[pw_carry]
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.mo.spindowndrpdh = 1
				player.mo.tyssondrpdsh = 0
			end
		end
	end
end)

addHook("JumpSpinSpecial", function(player)
	if player.mo and player.mo.skin == "hessesonic"
	and player.playerstate == PST_LIVE
	and not player.powers[pw_carry]
	and player.mo.spindowndrpdh == 0
	and not (player.pflags & PF_THOKKED)
	and player.mo.spindowndrpdh2 == 0
		if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
		and not player.powers[pw_super]
		and not CBW_Battle
			S_StartSound(player.mo, sfx_wdjump)
			for i = 1,18
				local wind = P_SPMAngle(player.mo,MT_SPINDUST,player.mo.angle+(ANG20*i),1)
				wind.target = player.mo
				wind.momz = 0
				wind.momy = 0
				wind.momx = 0
				P_InstaThrust(wind,wind.angle,17*FRACUNIT)
				P_SetObjectMomZ(wind, FRACUNIT*7)
			end
			if (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
			else
				P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
			end
		end
		if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
		and not player.powers[pw_super]
		and not CBW_Battle
			A_OldRingExplode(player.mo, MT_SONIC3KBOSSEXPLODE)
			P_BlackOw(player)
			P_StartQuake(20*FRACUNIT, 35, {0, 0, 0}, player.mo.radius)
			P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
			P_StartQuake(79*FRACUNIT, 3)
			P_FlashPal(player, PAL_WHITE, 3)
			S_StartSound(player.mo, sfx_bkpoof)
			P_NukeEnemies(player.mo, player.mo, RING_DIST)
			S_StartSound(player.mo, sfx_bgxpld)
			player.mo.alreadyexploded = true
		end
		if (player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT or player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN)
		and not player.powers[pw_super]
		and not CBW_Battle
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
				S_StartSound(player.mo, sfx_kc5b)
				S_StartSound(player.mo, sfx_kc4d)
				S_StartSound(player.mo, sfx_s3k45)
				if (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
				else
					P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
				end
			end
		end
		if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
		and not player.powers[pw_super]
		and not CBW_Battle
			player.pflags = $1|PF_SHIELDABILITY
			for d = 0,7
				local pumatrail = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PUMATRAIL)
				pumatrail.sttspeed = 2
				pumatrail.tics = 8
				pumatrail.scale = player.mo.scale
				P_InstaThrust(pumatrail, player.mo.angle+(ANGLE_45*d), 35*FRACUNIT)
			end
		end
		if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
		and not player.powers[pw_super]
		and not CBW_Battle
			player.pflags = $1|PF_SHIELDABILITY
			S_StartSound(player.mo, sfx_fire)
			S_StartSound(player.mo, sfx_zoom, player)
			local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok.state = S_FACESTABBERSPEAR
			thok.angle = player.drawangle+ANGLE_90
			thok.scale = player.mo.scale
			thok.fuse = 5
			thok.frame = $ & ~FF_TRANSMASK | TR_TRANS30
			thok.tics = 20
			thok.blendmode = AST_ADD
			thok.destscale = $*2
			thok.color = SKINCOLOR_KETCHUP
			thok.colorized = true
			P_Thrust(player.mo, player.mo.angle, player.speed)
		end
		if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
			if not player.powers[pw_super]
			and not CBW_Battle
				player.mo.state = S_PLAY_FALL
				S_StartSound(player.mo, sfx_zoom)
				P_SetObjectMomZ(player.mo, -38*FRACUNIT, false)
				player.pflags = $1|PF_SHIELDABILITY
			end
		end
		player.mo.spindowndrpdh2 = 1
		player.pflags = $1 & ~PF_SPINNING
		player.mo.tyssondrpdsh = 1
		player.mo.spindowndrpdh = 1
		player.hesse_levipower = 0
		S_StartSound(player.mo, sfx_dropd)
		local tyssonmode = P_SpawnGhostMobj(player.mo) 
		if tyssonmode and tyssonmode.valid
			tyssonmode.color = player.mo.color
			tyssonmode.colorized = true
			tyssonmode.destscale = $ * 5
			tyssonmode.blendmode = AST_ADD
			tyssonmode.target = player.mo
		end
	end
end)